part of xsch;

extension BuilderSchWidget on XSchedaState {
  /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT
  /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT
  /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT
  /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT /// LAYOUT
  ///Dialog per l'editing dei Numeri non Importi
  Widget xEditDialog_Number(XFDataItem item, XCol xCol, TextEditingController textController, void Function(void Function())? parentSetState, {bool btnNumberActive = true}) {
    return Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
      btnNumberActive
          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
              Expanded(
                  child: Wrap(spacing: 6, runSpacing: 6, children: [
                builderXEditDialog_BTNs(item, textController, "-20", false, parentSetState!, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-10", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-5", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-3", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "-1", false, parentSetState, xCol: xCol),
              ]))
            ])
          : Container(height: 0),
      SizedBox(height: btnNumberActive ? 10 : 1),
      Row(mainAxisAlignment: MainAxisAlignment.center, children: [
        Expanded(
            child: XTextFormField(
          height: null,
          textAlign: TextAlign.end,
          controller: textController,
          contentPadding: EdgeInsets.all(7),
          keyboardType: TextInputType.number,
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,.\\\\]"))],
        )),
        SizedBox(width: 10),
        builderXEditDialog_BTNs(item, textController, "C", false, parentSetState!),
      ]),
      SizedBox(height: btnNumberActive ? 10 : 1),
      btnNumberActive
          ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
              Expanded(
                  child: Wrap(spacing: 6, runSpacing: 6, children: [
                builderXEditDialog_BTNs(item, textController, "+20", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+10", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+5", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+3", false, parentSetState, xCol: xCol),
                builderXEditDialog_BTNs(item, textController, "+1", false, parentSetState, xCol: xCol),
              ]))
            ])
          : Container(height: 0)
    ]);
  }

  ///Dialog per l'editing dello sconto
  Widget xEditDialog_Sconto(
    XFDataItem item,
    XCol xCol,
    TextEditingController textController,
    void Function(void Function())? parentSetState, {
    List<ScontiBTN>? liSconti,
    bool calc = false,
  }) {
    return Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
      Row(children: [
        Expanded(child: Container(decoration: BoxDecoration(border: Border.all(color: Colors.white)), child: Text(textController.text, style: XStyles.xStyTextForSubLabel()))),
        XBtnbase(
            icon: Icons.arrow_back,
            width: 50,
            height: 50,
            onPressed: () {
              parentSetState!(() {
                if (textController.text.contains("+")) {
                  var x = textController.text.split("+");
                  if (x.length > 1)
                    textController.text = textController.text.replaceRange(textController.text.length - 3, textController.text.length, "");
                  else
                    textController.text = "";
                } else {
                  textController.text = "";
                }
              });
            })
      ]),
      SizedBox(height: 10),
      Row(children: [
        Expanded(
            child: Column(children: [
          Row(mainAxisAlignment: MainAxisAlignment.center, children: [
            Expanded(
                child: Wrap(
                    alignment: WrapAlignment.end,
                    spacing: 6,
                    runSpacing: 6,
                    children: liSconti != null
                        ? liSconti.where((element) => element.positionY == 0 && element.positionX == null).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList()
                        : [
                            builderXEditDialog_BTNs(item, textController, "+25", true, parentSetState!),
                            builderXEditDialog_BTNs(item, textController, "+40", true, parentSetState),
                            builderXEditDialog_BTNs(item, textController, "+48", true, parentSetState),
                          ]))
          ]),
          SizedBox(height: 10),
          Row(children: [
            calc
                ? Container()
                : Expanded(
                    child: XTextFormField(
                    height: null,
                    textAlign: TextAlign.end,
                    controller: xController_Sconto,
                    contentPadding: EdgeInsets.all(7),
                    keyboardType: TextInputType.number,
                    inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,.\\\\]"))],
                  ))
          ]),
          SizedBox(height: 10),
          Row(mainAxisAlignment: MainAxisAlignment.center, children: [
            Expanded(
                child: Wrap(
              alignment: WrapAlignment.end,
              spacing: 6,
              runSpacing: 6,
              children: liSconti != null
                  ? liSconti.where((element) => element.positionY == 1 && element.positionX == null).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList()
                  : [
                      builderXEditDialog_BTNs(item, textController, "+20", true, parentSetState!),
                      builderXEditDialog_BTNs(item, textController, "+15", true, parentSetState),
                      builderXEditDialog_BTNs(item, textController, "+10", true, parentSetState),
                    ],
            ))
          ])
        ])),
        Container(
            width: 50,
            child: Column(mainAxisSize: MainAxisSize.min, children: [
              Column(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: liSconti != null
                      ? liSconti.where((element) => element.positionY == 0 && element.positionX != null && element.positionX! > 1).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList() //
                      : [builderXEditDialog_BTNs(item, textController, "+50", true, parentSetState!)]),
              SizedBox(height: 7),
              XBtnbase(
                  icon: Icons.add,
                  width: 50,
                  height: 40,
                  onPressed: () {
                    parentSetState!(() {
                      if (xController_Sconto.text.length < 1) {
                      } else {
                        if (textController.text == "")
                          textController.text += xController_Sconto.text;
                        else
                          textController.text += ("+" + xController_Sconto.text);

                        xController_Sconto.text = "";
                      }
                    });
                    xController_Sconto.clear();
                  }),
              SizedBox(height: 7),
              Column(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: liSconti != null
                      ? liSconti.where((element) => element.positionY == 1 && element.positionX != null && element.positionX! > 1).map((e) => builderXEditDialog_BTNs(item, textController, e.scontoValue, true, parentSetState!)).toList() //
                      : [builderXEditDialog_BTNs(item, textController, "+5", true, parentSetState!)]),
            ]))
      ])
    ]);
  }

  ///Dialog per l'editing dei campi con i vari pulsanti di help
  Future<dynamic> xEditDialog(XFDataItem item, String title, dynamic value, XCol xCol, {List<ScontiBTN>? liSconti, bool btns_Active = true}) async {
    XFDataItem itemClone = item.getCloneFull();
    FocusScope.of(context).unfocus();
    TextEditingController textController = TextEditingController(
        text: itemClone[xCol.colKey].runtimeType != DateTime
            ? itemClone[xCol.colKey].toString()
            : itemClone[xCol.colKey] != null
                ? XUtils.dateToString(itemClone[xCol.colKey], format: "dd/MM/yyyy", noDateLabel: "")
                : XUtils.dateToString(DateTime.now(), format: "dd/MM/yyyy", noDateLabel: ""));
    if (enteredInEditOnCell.not()) setState(() => enteredInEditOnCell = true);
    var clipboard_isFull = await Clipboard.getData("text/plain");
    var res = await showDialog<dynamic>(
        context: context,
        barrierDismissible: false,
        barrierColor: Colors.black.withAlpha(230),
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                width: MediaQuery.of(context).size.width - 10,
                alignment: Alignment.center,
                child: SingleChildScrollView(
                    child: XAlertDialog(
                        colorBackGround: XSchedaState.color_BackGround_EditDialog,
                        actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                        content_insetPadding: EdgeInsets.all(2),
                        width: MediaQuery.of(context).size.width - 10,
                        content_VerticalPadding: 2,
                        height: null,
                        title_Text: title,
                        title_Style: XStyles.xStyTextForLabel(textColor: Colors.blue),
                        btnNO_OnPressed: () => Navigator.pop(context, null),
                        actionsBTNarea_Child: Container(
                            padding: EdgeInsets.only(bottom: 10),
                            child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                              XBtnbase(
                                width: 120,
                                label: "Annulla",
                                label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.red),
                                backGroundColor: Colors.red.withAlpha(60),
                                onPressed: () => Navigator.pop(context, null),
                              ),
                              SizedBox(width: 10),
                              XBtnbase(
                                  width: 120,
                                  label: "OK",
                                  label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.green),
                                  backGroundColor: Colors.green.withAlpha(60),
                                  onPressed: () {
                                    if (value != textController.text) setState(() => editedPage.value = true);
                                    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
                                      value = textController.text;
                                    } else if (xCol.dataType == DateTime) {
                                      value = itemClone[xCol.colKey];
                                    } else if (xCol.dataType == double) {
                                      if (textController.text != "") {
                                        value = double.parse(textController.text);
                                      } else {
                                        value = 0.0;
                                      }
                                    } else if (xCol.dataType == int) {
                                      if (textController.text != "") {
                                        value = int.parse(textController.text);
                                      } else {
                                        value = 0;
                                      }
                                    }
                                    // lo fa già xOnXCell_Edit_SubmitValue
                                    xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                                    Navigator.pop(context, value);
                                  })
                            ])),
                        child: xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: itemClone) != null
                            ? xEditDialog_Override_Editor(xCol.colCaption, value, xCol, textController, item: itemClone)
                            : (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != DateTime && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                ? xEditDialog_Sconto(itemClone, xCol, textController, setState, liSconti: liSconti)
                                : Column(mainAxisAlignment: MainAxisAlignment.center, crossAxisAlignment: CrossAxisAlignment.start, children: [
                                    SizedBox(height: 3),
                                    (xCol.dataType == String && xCol.colKey.startsWith("li").not() && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                        ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                            Expanded(child: xEditDialog_CellBuilder(itemClone, xCol, context, setState, textController)),
                                            SizedBox(width: 10),
                                            builderXEditDialog_BTNs(itemClone, textController, "C", false, setState),
                                          ])
                                        : xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                            ? Column(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                Row(children: [Expanded(child: xEditDialog_CellBuilder(itemClone, xCol, context, setState, textController))]),
                                                SizedBox(height: 10),
                                                Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                                                  clipboard_isFull != null
                                                      ? XBtnbase(
                                                          width: 60,
                                                          label: "Incolla",
                                                          label_TextAlign: TextAlign.center,
                                                          label_Color: Colors.white,
                                                          padding: EdgeInsets.all(0),
                                                          backGroundColor: Colors.grey[700],
                                                          onPressed: () async {
                                                            await Clipboard.getData("text/plain").then((value) => textController.text += " " + (value != null ? (value.text ?? "") : ""));
                                                            ScaffoldMessenger.of(context).showSnackBar(SnackBar(content: Text('Testo incollato dagli appunti')));
                                                          })
                                                      : Container(),
                                                  SizedBox(width: 20),
                                                  XBtnbase(
                                                      width: 60,
                                                      label: "Copia \nTutto",
                                                      label_TextAlign: TextAlign.center,
                                                      label_Color: Colors.white,
                                                      padding: EdgeInsets.all(0),
                                                      backGroundColor: Colors.grey[700],
                                                      onPressed: () {
                                                        Clipboard.setData(ClipboardData(text: textController.text));
                                                        ScaffoldMessenger.of(context).showSnackBar(SnackBar(content: Text('Testo copiato negli appunti')));
                                                      }),
                                                  SizedBox(width: 20),
                                                  builderXEditDialog_BTNs(itemClone, textController, "C", false, setState),
                                                ])
                                              ])
                                            : xCol.dataType == DateTime
                                                ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [Expanded(child: xEditDialog_CellBuilder(itemClone, xCol, context, setState, textController))]) //
                                                : Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                                    Expanded(child: xEditDialog_CellBuilder(itemClone, xCol, context, setState, textController)),
                                                    SizedBox(width: 10),
                                                    builderXEditDialog_BTNs(itemClone, textController, "C", false, setState),
                                                  ]),
                                    SizedBox(height: 10),
                                    btns_Active && ((xCol.dataType == String).not() && xCol.dataType != DateTime)
                                        ? Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                            Expanded(
                                                child: Wrap(alignment: WrapAlignment.end, spacing: 8, runSpacing: 8, children: [
                                              builderXEditDialog_BTNs(itemClone, textController, "+20", false, setState, xCol: xCol),
                                              builderXEditDialog_BTNs(itemClone, textController, "+10", false, setState, xCol: xCol),
                                              builderXEditDialog_BTNs(itemClone, textController, "+5", false, setState, xCol: xCol),
                                              builderXEditDialog_BTNs(itemClone, textController, "+3", false, setState, xCol: xCol),
                                              xCol.dataType == String && xCol.colKey.startsWith("li").not() ? Container() : builderXEditDialog_BTNs(itemClone, textController, "+1", false, setState, xCol: xCol),
                                            ]))
                                          ])
                                        : Container(),
                                  ]))));
          });
        });
    return res;
  }

  ///Gestione dell'aggiunta di un Item
  Future<XFDataItem?> xLayout_DialogAddItem(XView xView, XFDataItem item, void Function(void Function()) setState, {List<ScontiBTN>? liSconti}) async {
    bool isFirst = false;
    int u = 0;
    setState(() {
      enteredInEditOnCell = true;
    });
    XFDataItem? rval = null;
    if (xView.cols.where((e) => e.dataType != bool || e.readOnly != true || e.colKey.startsWith("li").not()).length == 1) {
      isFirst = false;
    } else {
      for (var i in xView.cols) {
        if (i.dataType == bool || i.readOnly == true || i.colKey.startsWith("li")) continue;
        u++;
        var x = await xEditDialog(item, i.colCaption, item[i.colKey], i, liSconti: liSconti);
        if (x == null) {
          if (u == 1) isFirst = true;
          break;
        } else {
          item[i.colKey] = x;
        }
      }
    }
    if (!isFirst) rval = await xPreview_Dialog(xView, item);
    setState(() => enteredInEditOnCell = false);
    return rval;
  }

  ///Preview dell'aggiunta di un nuovo Item
  Future<XFDataItem?> xPreview_Dialog(XView xView, dynamic value, {String? BTNyes_Label, String? title_Text, bool autoFocusOfCells = true}) async {
    xController_Sconto.text = "";
    return await showDialog<XFDataItem?>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                width: MediaQuery.of(context).size.width - 20,
                alignment: Alignment.center,
                child: SingleChildScrollView(
                    child: XAlertDialog(
                        actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                        content_insetPadding: EdgeInsets.all(3),
                        content_VerticalPadding: 5,
                        width: MediaQuery.of(context).size.width - 20,
                        colorBackGround: XSchedaState.color_BackGround_EditDialog,
                        title_Text: title_Text,
                        actionsBTNarea_Child: Container(
                            padding: EdgeInsets.only(bottom: 10),
                            child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                              XBtnbase(
                                width: 120,
                                label: "Annulla",
                                label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.red),
                                backGroundColor: Colors.red.withAlpha(60),
                                onPressed: () => Navigator.pop(context, null),
                              ),
                              SizedBox(width: 10),
                              XBtnbase(
                                width: 120,
                                label: "Conferma",
                                label_Style: XStyles.xStyTextForSubLabel(textColor: Colors.green),
                                backGroundColor: Colors.green.withAlpha(60),
                                onPressed: () {
                                  editedPage.value = true;
                                  xBottomBarAction_Fill();
                                  return Navigator.pop(context, value);
                                },
                              ),
                            ])),
                        child: Column(
                          mainAxisSize: MainAxisSize.min,
                          children: xView.cols.map((e) {
                            TextEditingController controller = TextEditingController(text: value[e.colKey].toString());
                            if (e.colKey.startsWith("li").not() && e.readOnly == false)
                              return Container(margin: EdgeInsets.symmetric(vertical: 5), child: xEditDialog_Override_Editor(e.colCaption, value, e, controller, item: value) ?? xEditDialog_CellBuilder(value, e, context, setState, controller, label_Visible: true, autoFocus: autoFocusOfCells, keyboardType: TextInputType.text));
                            else
                              return Container();
                          }).toList(),
                        ))));
          });
        });
  }

  ///CellBuilder dellxEntry
  Container xEditDialog_CellBuilder(XFDataItem item, XCol xCol, BuildContext context, void Function(void Function()) setState, TextEditingController controller, {TextInputType? keyboardType, bool autoFocus = true, bool label_Visible = false, List<TextInputFormatter>? inputFormatters}) {
    Widget _widgetForCell = Container();
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        xCol: xCol,
        autoFocus: autoFocus,
        controller: controller,
        label_Visible: label_Visible,
        multiLines: xCol.multilines,
        maxLines: xCol.multilines ? 4 : 1,
        inputFormatters: inputFormatters,
        editable: xCol.readOnly,
        keyboardType: keyboardType,
        borderColor: widget.xCell_borderColor,
        borderColor_Disabled: widget.xCell_borderColor_Disabled,
        labelColor_Disabled: widget.xCell_labelColor_Disabled,
        onSubmitted: (p0) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, p0),
        onBefore_Edit: () {},
        onChanged: (value) => item[xCol.colKey] = value,
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          onBefore_Edit: () {},
          value: item[xCol.colKey],
          onDateSelected: (value) {
            item[xCol.colKey] = value;
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          label_Visible: label_Visible,
          maxLines: 1,
          borderColor: widget.xCell_borderColor,
          borderColor_Disabled: widget.xCell_borderColor_Disabled,
          labelColor_Disabled: widget.xCell_labelColor_Disabled,
          autoFocus: true,
          onBefore_Edit: () {},
          keyboardType: TextInputType.number,
          controller: controller,
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) => xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value)),
          onChanged: (value) {
            if (value != "")
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            else
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        label_Visible: label_Visible,
        autoFocus: true,
        xCol: xCol,
        borderColor: widget.xCell_borderColor,
        borderColor_Disabled: widget.xCell_borderColor_Disabled,
        labelColor_Disabled: widget.xCell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {},
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        controller: controller,
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "")
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          else
            xOnXCell_Edit_OnChanged(item, xCol, 0);
        },
      );
    } else {
      return Container(width: 0, height: 0);
    }
    return Container(margin: EdgeInsets.only(top: 2), child: StatefulBuilder(builder: (context, setState) => _widgetForCell));
  }

  ///TextFormField Editor Generico da Usare
  Widget xSch_TextFormField_Builder<T>({
    required BuildContext context,
    required XCol xCol,
    Function(String)? onChanged,
    Function(String)? onSubmitted,
    String? hintText,
    List<TextInputFormatter>? inputFormatters,
    TextInputType? keyboardType,
    bool editable = true,
    bool label_Visible = true,
    bool autoFocus = false,
    String? value,
    bool? selectText,
    bool? multiLines,
    double? height,
    int? maxLines,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Color? backgorundColor,
    Color? textColor,
    Color? backgorundColor_Disabled,
    TextEditingController? controller,
    Function()? onBefore_Edit,
  }) {
    OutlineInputBorder o = OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor_Active ? (xCol.xmodelXprop.col_Color == Colors.black ? (borderColor ?? Colors.grey[400]!) : xCol.xmodelXprop.col_Color) : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[400]!), width: 1));
    return Container(
        margin: EdgeInsets.only(top: 2),
        child: XTextFormField(
          controller: value != null ? null : controller,
          border: o,
          disabledBorder: o,
          enabledBorder: o,
          label: label_Visible ? xCol.colCaption + (editable ? "🔒" : "") : "",
          onChanged: onChanged,
          onFieldSubmitted: (value) => onSubmitted == null ? null : onSubmitted(value!),
          autoFocus: autoFocus,
          onTap: () {
            if (controller != null && xCol.dataType != String) controller.selection = TextSelection(baseOffset: 0, extentOffset: controller.text.length);
            onBefore_Edit!();
          },
          initialValue: controller != null ? null : value,
          maxLines: maxLines,
          isCollapsed: false,
          enabled: editable.not(),
          height: null,
          fillColor: editable ? Colors.transparent : XSchedaState.color_CellBackGorundDisabled,
          filled: XSchedaState.color_CellBackGorundDisabled != null ? true : false,
          multiLines: (xCol.colCaption.toLowerCase().contains("email") || (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")) || xCol.colCaption.toLowerCase().contains("inidrizzo") || xCol.colCaption.toLowerCase().contains("ind"))
              ? false
              : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
                  ? false
                  : multiLines ?? false,
          suffixIcon: xCol.format == "C" ? Icon(Icons.euro, size: 20) : null,
          suffixIconConstraints: BoxConstraints(maxWidth: 20, minWidth: 20, maxHeight: 30, minHeight: 30),
          contentPadding: EdgeInsets.only(top: 8, left: 5, bottom: 8),
          textStyle: XStyles.xStyleText(colorText: textColor ?? XSchedaState.color_Text),
          textAlign: xCol.dataType is int || xCol.dataType is double ? TextAlign.end : TextAlign.start,
          labelStyle: XStyles.xStyTextForLabel(textColor: xCol.xmodelXprop.col_Color == Colors.black ? XColors.foregroundLight : xCol.xmodelXprop.col_Color), //XSchedaState.colorOfHintText
          keyboardType: keyboardType ??
              ((xCol.colCaption.toLowerCase().contains("email"))
                  ? TextInputType.emailAddress
                  : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
                      ? TextInputType.phone
                      : (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto"))
                          ? TextInputType.number
                          : TextInputType.text),
          textCapitalization: (xCol.dataType == String && xCol.colKey.startsWith("li").not())
              ? TextCapitalization.sentences //
              : TextCapitalization.none,
          hintText: editable ? "..." : (hintText ?? "..."),
          hintStyle: XStyles.xStyTextForSubDescr(textColor: XSchedaState.color_HintText),
          inputFormatters: inputFormatters ?? [],
        ));
  }

  ///Text Generico da Usare
  Widget xSch_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xFormatToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(textColor: Colors.white),
      label_Style: XStyles.xStyTextForLabel(textColor: XSchedaState.color_HintText),
    );
  }

  ///DateTime Editor Generico da Usare
  Widget xSch_DateFormField_Builder({
    required XCol xCol,
    required Function(DateTime)? onDateSelected,
    bool editable = true,
    DateTime? value,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Function()? onBefore_Edit,
    TextEditingController? controller,
    String? format,
  }) {
    OutlineInputBorder o = OutlineInputBorder(borderSide: BorderSide(color: xCol.readOnly.not() ? (borderColor_Active ? xCol.xmodelXprop.col_Color : borderColor ?? Colors.grey[400]!) : (borderColor_Disabled ?? Colors.grey[800]!), width: 1));
    return GestureDetector(
        child: Container(
            margin: EdgeInsets.only(top: 1),
            child: DateTimeFormField(
                decoration: InputDecoration(
                  contentPadding: EdgeInsets.only(right: 2, top: 6, bottom: 6, left: 4),
                  hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.color_HintText),
                  errorStyle: TextStyle(color: Colors.redAccent),
                  border: o,
                  disabledBorder: o,
                  enabledBorder: o,
                  labelText: xCol.colCaption,
                  constraints: BoxConstraints(maxHeight: 48),
                  labelStyle: value != null
                      ? XStyles.xStyTextForLabel(textColor: xCol.readOnly ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[900]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)) //
                      : XStyles.xStyTextForDescr(textColor: editable.not() ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight)),
                ),
                enabled: xCol.readOnly.not(),
                initialValue: value,
                dateFormat: DateFormat(format ?? "dd/MM/yy"),
                dateTextStyle: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
                initialEntryMode: DatePickerEntryMode.calendar,
                initialDatePickerMode: DatePickerMode.day,
                mode: DateTimeFieldPickerMode.date,
                autovalidateMode: AutovalidateMode.onUserInteraction,
                validator: (e) => (e?.day ?? 0) == 1 ? 'Perfavore sistema la data' : null,
                onDateSelected: (value) => onDateSelected!(value))));
  }

  ///Builder del Widget per la visualizzazione delle IMMAGINI sulla riga degli Items
  Widget xLayout_Builder_ImmaginiArea(List<XMediaItem>? liImage, {String? parentID, DateTime? dt}) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liImage!
                    .where((element) => element.xDocID == (parentID))
                    .map((element) => GestureDetector(
                          onTap: () => cmd_OpenPhoto(element.payload!, element.id, dtImage: dt),
                          child: Container(margin: EdgeInsets.symmetric(horizontal: 5), width: 100, child: Image.memory(element.payload!, width: 100, height: 100)),
                        ))
                    .toList())));
  }

  ///Builder del Widget per la visualizzazione dei VIDEO sulla riga degli Items
  Widget xLayout_Builder_VideoArea(List<dynamic>? liVideo, XFDataItem? xclItem) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liVideo!.where((element) => element.xDocID == xclItem!.id).map((element) {
              return GestureDetector(
                  onTap: () async {
                    File x = await File.fromUri(Uri.parse(element.blobURL!));
                    VideoPlayerController? videoPlayerController = await VideoPlayerController.file(x);
                    bool _isPlaying = false;
                    Future<void> _playVideo() async => await videoPlayerController.play().then((value) => setState(() {}));
                    Future<void> _pauseVideo() async => await videoPlayerController.pause().then((value) => setState(() {}));

                    return showDialog(
                        context: context,
                        builder: (context) {
                          videoPlayerController
                            ..addListener(() {
                              final bool isPlaying = videoPlayerController.value.isPlaying;
                              if (isPlaying != _isPlaying) setState(() => _isPlaying = isPlaying);
                            })
                            ..initialize().then((_) => setState(() {}));
                          var i;
                          i = liVideo.firstWhereOrNull((element) => element.xDocID == element.id) != null;

                          return XAlertDialog(
                            content_insetPadding: EdgeInsets.all(0),
                            title_TextAlign: TextAlign.center,
                            title_Text: i != null ? "Video del Lavoro" : "Video del Dettaglio",
                            actionsBTNarea_Child: Row(children: [
                              Expanded(
                                  child: XBtnbase(
                                label: "Pausa",
                                onPressed: () => _pauseVideo(),
                                label_Style: XStyles.xStyTextForLabel(textColor: Colors.yellow),
                              )),
                              Expanded(
                                  child: XBtnbase(
                                label: "Play",
                                onPressed: () => _playVideo(),
                                label_Style: XStyles.xStyTextForLabel(textColor: Colors.green),
                              ))
                            ]),
                            child: Stack(children: [Container(width: MediaQuery.of(context).size.width - 10, child: VideoPlayer(videoPlayerController))]),
                          );
                        }).then((value) => videoPlayerController.dispose());
                  },
                  child: Container(
                    margin: EdgeInsets.symmetric(horizontal: 5),
                    decoration: BoxDecoration(color: Colors.grey[800], image: DecorationImage(image: MemoryImage(element.miniatura!))),
                    width: 100,
                    height: 100,
                    child: Container(child: Icon(Icons.play_arrow, size: 28)),
                  ));
            }).toList())));
  }

  ///Builder del Widget per la visualizzazione degli AUDIO sulla riga degli Items
  Widget xLayout_Builder_AudioArea(List<XMediaItem>? liAudio, XFDataItem xclItem) {
    return Container(
        margin: EdgeInsets.only(bottom: 7),
        child: SingleChildScrollView(
            scrollDirection: Axis.horizontal,
            child: Row(
                children: liAudio!
                    .where((element) => element.xDocID == xclItem.id)
                    .map((element) => GestureDetector(
                        onTap: () {},
                        child: Container(
                            margin: EdgeInsets.symmetric(horizontal: 5),
                            width: 100,
                            color: Colors.grey[800],
                            height: 100,
                            child: Container(
                                child: IconButton(
                                    icon: Icon(element.isShowDetails ? Icons.block : Icons.mic, size: 28),
                                    onPressed: () async {
                                      setState(() => element.isShowDetails = !element.isShowDetails);
                                      if (element.isShowDetails) await play(element.payload!, setState).whenComplete(() => setState(() => element.isShowDetails = false));
                                    })))))
                    .toList())));
  }

  ///Builder dei bottoni cher verranno visualizzati nell'XEditDialog
  XBtnbase builderXEditDialog_BTNs(XFDataItem item, TextEditingController controller, String valueAndLabel, bool isSconto, void Function(void Function()) parentSetState, {XCol? xCol}) {
    return XBtnbase(
        padding: EdgeInsets.all(1),
        width: 45 * XUtils.kforScale,
        label_Style: XStyles.xStyTextForSubLabel(
            textColor: valueAndLabel.contains("+")
                ? Colors.green
                : valueAndLabel.contains("-") || valueAndLabel == ("C")
                    ? Colors.red
                    : Colors.green),
        label: valueAndLabel,
        backGroundColor: Colors.grey[700],
        onPressed: () {
          if (valueAndLabel == "C") {
            controller.text = "";
            FocusScope.of(context).unfocus();
          } else {
            if (isSconto) {
              parentSetState(() => controller.text += calcSconto(controller, valueAndLabel));
            } else {
              if (valueAndLabel.contains("-")) {
                calcCell_Negative(xCol!, controller, int.parse(valueAndLabel.replaceFirst("-", "")));
              } else {
                calcCell_Positive(xCol!, controller, int.parse(valueAndLabel.replaceFirst("+", "")));
              }
            }
            controller.selection = TextSelection(baseOffset: controller.text.length, extentOffset: controller.text.length);
          }
        });
  }

  /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL
  /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL
  /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL
  /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL /// BL

  ///Comando per l'Aggiunta di una Riga all'elenco partendo da un cliente
  /// !!! OBBLIGATORIO passargli un Cliente !!!
  Future xCMD_AddNew_FromCliente<T, XFDataItem>(
    T newObj,
    List<Contact> liContatti,
    List<DynamicCli> liCliente, {
    Future Function(T newOBJ, DynamicCli cliente)? onAddObj_FromCliExist,
    Future Function(T newOBJ, String alias, String nome, String cognome, String cell, String email, String referente)? onAddObj_FromCliRubrica,
    Future Function(T newOBJ, String alias, String nome, String cognome, String cell, String email, String referente)? onAddObj_FromCliInput,
    Future Function(T newOBJ)? onSaveAfter_Cliente,
    bool isActive_input_ALIAS = true,
    bool isActive_input_NOME = true,
    bool isActive_input_COGNOME = true,
    bool isActive_input_CELL = true,
    bool isActive_input_EMAIL = true,
    bool isActive_input_REFERENTE = true,
  }) async {
    dynamic cliente_UI;
    TextEditingController alias_textEditingController_UI = TextEditingController();
    TextEditingController nome_textEditingController_UI = TextEditingController();
    TextEditingController cognome_textEditingController_UI = TextEditingController();
    TextEditingController cell_textEditingController_UI = TextEditingController();
    TextEditingController email_textEditingController_UI = TextEditingController();
    TextEditingController nomeReferente_textEditingController_UI = TextEditingController();
    String? _alias_UI;
    String? _nome_UI;
    String? _cognome_UI;
    String? _cell_UI;
    String? _email_UI;
    String? _nomeReferente_UI;

    Contact? xclContact;

    bool cli_exist = false;
    bool cli_rubrica = false;
    bool loadingRubrica = false;
    var res = await showDialog<bool?>(
        barrierDismissible: false,
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return Container(
                child: XAlertDialog(
                    height: 200,
                    colorBackGround: Colors.grey[900],
                    actionsBTNarea_Padding: EdgeInsets.all(5),
                    content_VerticalPadding: 5,
                    btnNO_OnPressed: () => Navigator.pop(context, false),
                    btnYES_OnPressed: () => Navigator.pop(context, true),
                    btnYES_label: "Avanti",
                    btnNO_label: "Annulla",
                    title_Text: "Contatto della Richiesta:",
                    child: Container(
                        alignment: Alignment.topCenter,
                        child: SingleChildScrollView(
                            child: Column(mainAxisSize: MainAxisSize.min, children: [
                          Row(children: [
                            isActive_input_NOME
                                ? Expanded(
                                    child: Autocomplete<DynamicCli>(
                                    fieldViewBuilder: (BuildContext context, TextEditingController textEditingController, FocusNode focusNode, VoidCallback onFieldSubmitted) {
                                      return XTextFormField(
                                        controller: nome_textEditingController_UI,
                                        borderWidth: 2,
                                        height: null,
                                        colorBorder: Colors.grey[900],
                                        focusNode: focusNode,
                                        autoFocus: true,
                                        border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                        hintText: "nome cliente...",
                                        labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                        hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textCapitalization: TextCapitalization.sentences,
                                        inputFormatters: [],
                                        onChanged: (value) {
                                          textEditingController.text = value;
                                          setState(() {
                                            if (value == "") {
                                              _nome_UI = null;
                                            } else {
                                              _nome_UI = value;
                                            }
                                            if (cliente_UI != null) {
                                              cliente_UI = null;
                                            } else {}
                                          });
                                        },
                                      );
                                    },
                                    displayStringForOption: (option) {
                                      return (option.nome ?? "") + " " + (option.cognome ?? "");
                                    },
                                    optionsBuilder: (TextEditingValue textEditingValue) {
                                      if (textEditingValue.text == '') {
                                        return Iterable<DynamicCli>.empty();
                                      } else {
                                        return liCliente.where((element) => element.nome!.toLowerCase().contains(textEditingValue.text.toLowerCase()));
                                      }
                                    },
                                    onSelected: (cli) {
                                      setState(() {
                                        cliente_UI = cli.getCloneFull();
                                        _nome_UI = "";
                                        alias_textEditingController_UI.text = cliente_UI!.nickname;
                                        nome_textEditingController_UI.text = cliente_UI!.nome ?? "";
                                        cognome_textEditingController_UI.text = cliente_UI!.cognome ?? "";
                                        email_textEditingController_UI.text = cliente_UI!.email ?? "";
                                        cell_textEditingController_UI.text = cliente_UI!.cell ?? "";
                                      });
                                    },
                                    initialValue: TextEditingValue(text: _nome_UI ?? ""),
                                  ))
                                : Container(),
                            SizedBox(width: 10),
                            isActive_input_COGNOME
                                ? Expanded(
                                    child: Autocomplete<DynamicCli>(
                                    fieldViewBuilder: (BuildContext context, TextEditingController textEditingController, FocusNode focusNode, VoidCallback onFieldSubmitted) {
                                      return XTextFormField(
                                        controller: cognome_textEditingController_UI,
                                        borderWidth: 2,
                                        colorBorder: Colors.grey[900],
                                        focusNode: focusNode,
                                        autoFocus: false,
                                        border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                        contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                        hintText: "cognome cliente...",
                                        labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                        hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                        textCapitalization: TextCapitalization.sentences,
                                        inputFormatters: [],
                                        onChanged: (value) {
                                          textEditingController.text = value;
                                          setState(() {
                                            if (value == "") {
                                              _cognome_UI = null;
                                            } else {
                                              _cognome_UI = value;
                                            }
                                            if (cliente_UI != null) {
                                              cliente_UI = null;
                                            } else {}
                                          });
                                        },
                                      );
                                    },
                                    displayStringForOption: (option) {
                                      return (option.cognome ?? "") + " " + (option.nome ?? "");
                                    },
                                    optionsBuilder: (TextEditingValue textEditingValue) {
                                      if (textEditingValue.text == '') {
                                        return Iterable<DynamicCli>.empty();
                                      } else {
                                        return liCliente.where((element) => element.cognome!.toLowerCase().contains(textEditingValue.text.toLowerCase()));
                                      }
                                    },
                                    onSelected: (cli) {
                                      setState(() {
                                        cliente_UI = cli.getCloneFull();
                                        _cognome_UI = "";
                                        alias_textEditingController_UI.text = cliente_UI!.nickname;
                                        nome_textEditingController_UI.text = cliente_UI!.nome ?? "";
                                        cognome_textEditingController_UI.text = cliente_UI!.cognome ?? "";
                                        email_textEditingController_UI.text = cliente_UI!.email ?? "";
                                        cell_textEditingController_UI.text = cliente_UI!.cell ?? "";
                                      });
                                    },
                                    initialValue: TextEditingValue(text: _nome_UI ?? ""),
                                  ))
                                : Container(),
                          ]),
                          isActive_input_ALIAS
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: alias_textEditingController_UI,
                                          borderWidth: 2,
                                          colorBorder: Colors.grey[900],
                                          autoFocus: true,
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          height: null,
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "alias...",
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textCapitalization: TextCapitalization.sentences,
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            alias_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _alias_UI = null;
                                              else
                                                _alias_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          })),
                                  SizedBox(width: 10)
                                ])
                              : Container(),
                          isActive_input_REFERENTE
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: nomeReferente_textEditingController_UI,
                                          borderWidth: 2,
                                          height: null,
                                          colorBorder: Colors.grey[900],
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "nome referente...",
                                          textCapitalization: TextCapitalization.sentences,
                                          keyboardType: TextInputType.name,
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            nomeReferente_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _nomeReferente_UI = null;
                                              else
                                                _nomeReferente_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          }))
                                ])
                              : Container(),
                          isActive_input_CELL
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: cell_textEditingController_UI,
                                          borderWidth: 2,
                                          height: null,
                                          colorBorder: Colors.grey[900],
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "cell...",
                                          textCapitalization: TextCapitalization.sentences,
                                          keyboardType: TextInputType.phone,
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            cell_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _cell_UI = null;
                                              else
                                                _cell_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          }))
                                ])
                              : Container(),
                          isActive_input_EMAIL
                              ? Row(children: [
                                  Expanded(
                                      child: XTextFormField(
                                          controller: email_textEditingController_UI,
                                          borderWidth: 2,
                                          height: null,
                                          colorBorder: Colors.grey[900],
                                          border: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          disabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          enabledBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          focusedBorder: UnderlineInputBorder(borderSide: BorderSide(color: Colors.grey[600]!)),
                                          contentPadding: EdgeInsets.only(bottom: 5, top: 8),
                                          hintText: "email...",
                                          keyboardType: TextInputType.emailAddress,
                                          labelStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          textStyle: XStyles.xStyTextForSubLabel(textColor: Colors.white),
                                          hintStyle: XStyles.xStyTextForSubLabel(textColor: Colors.grey[600]!),
                                          inputFormatters: [],
                                          onChanged: (value) {
                                            email_textEditingController_UI.text = value;
                                            setState(() {
                                              if (value == "")
                                                _email_UI = null;
                                              else
                                                _email_UI = value;
                                              if (cliente_UI != null) cliente_UI = null;
                                            });
                                          }))
                                ])
                              : Container(),
                          SizedBox(height: 20),
                          Row(children: [
                            onAddObj_FromCliRubrica != null
                                ? Expanded(
                                    child: loadingRubrica
                                        ? Container(child: XStatefulWidgetBase.LoaderIndicator(loadingRubrica, fixHeight: 40, fixWidth: 40, label: "Caricamento"))
                                        : XBtnbase(
                                            backGroundColor: Colors.grey[800],
                                            toolTip_Message: "Inserisci un nuovo Cliente dalla Rubrica",
                                            label: "Da Rubrica",
                                            label_Color: Colors.blue,
                                            onPressed: () async {
                                              cli_rubrica = true;
                                              setState(() => loadingRubrica = true);
                                              xclContact = await xCMD_AddFromRubrica(liContatti);
                                              setState(() => loadingRubrica = false);
                                              if (xclContact != null) {
                                                setState(() {
                                                  if (xclContact!.phones != null && xclContact!.phones!.isNotEmpty) {
                                                    _alias_UI = (xclContact!.givenName ?? "") + " " + (xclContact!.familyName ?? "");
                                                    _nome_UI = (xclContact!.givenName ?? "");
                                                    _cognome_UI = (xclContact!.familyName ?? "");
                                                    _cell_UI = xclContact!.phones!.first.value ?? "";
                                                    _email_UI = "";
                                                  }
                                                });
                                              }
                                              Navigator.pop(context, true);
                                            }))
                                : Container(),
                            (onAddObj_FromCliRubrica != null && onAddObj_FromCliExist != null) ? SizedBox(width: 10) : Container(),
                            onAddObj_FromCliExist != null
                                ? Expanded(
                                    child: XBtnbase(
                                        backGroundColor: Colors.grey[800],
                                        toolTip_Message: "Usa un Cliente gia esistente",
                                        label: "Da Esistente",
                                        label_Color: Colors.green,
                                        onPressed: () {
                                          cliente_UI = null;
                                          cli_exist = true;
                                          Navigator.pop(context, true);
                                        }))
                                : Container(),
                          ])
                        ])))));
          });
        });
    if (res != null && res) {
      if (cli_exist) {
        var res = await cmd_AddCliFromExist(liCliente);
        if (res != null) {
          await onAddObj_FromCliExist!(newObj, res);
        } else {
          return xCMD_AddNew_FromCliente(newObj, liContatti, liCliente);
        }
      } else if (cli_rubrica) {
        if (xclContact != null) await onAddObj_FromCliRubrica!(newObj, _alias_UI ?? "", _nome_UI ?? "", _cognome_UI ?? "", _cell_UI ?? "", _email_UI ?? "", _nomeReferente_UI ?? "");
      } else {
        if (_alias_UI != "") await onAddObj_FromCliInput!(newObj, _alias_UI ?? "", _nome_UI ?? "", _cognome_UI ?? "", _cell_UI ?? "", _email_UI ?? "", _nomeReferente_UI ?? "");
      }
      await onSaveAfter_Cliente!(newObj);
    }
  }

  Future<dynamic> cmd_AddCliFromExist(List<dynamic> liCliente) async {
    dynamic xclCliente;
    var x = await showDialog<dynamic>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            return XAlertDialog(
                title_Text: "Scegli il Cliente tra quelli esistenti:",
                height: null,
                content_VerticalPadding: 30,
                child: XDropSearch<dynamic>(
                  dropDownMode: "Dialog",
                  al_Title: "",
                  al_BackGroundColor: Colors.grey[900],
                  itemSelected: xclCliente,
                  liItems: liCliente.where((element) => element.nome!.isNotEmpty || element.cognome!.isNotEmpty).toList(),
                  label: "",
                  itemAsString: (p0) => (p0.nome ?? "") + " " + (p0.cognome ?? ""),
                  onChanged_ItemOfDD: (cli) => setState(() => xclCliente = cli),
                ),
                actionsBTNarea_Child: Row(children: [
                  Expanded(
                      child: XBtnbase(
                    label: "Annulla",
                    onPressed: () => Navigator.pop(context, null),
                    label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.undo),
                  )),
                  xclCliente != null
                      ? Expanded(
                          child: XBtnbase(
                          label: "Avanti",
                          onPressed: () => Navigator.pop(context, xclCliente),
                          label_Style: XStyles.xStyTextForSubLabel(textColor: XColors.done),
                        ))
                      : Container()
                ]));
          });
        });
    if (x != null && xclCliente != null) {
      return xclCliente;
    } else {
      return null;
    }
  }

  calcCell_Negative(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (controller.text == "") {
    } else {
      if (xCol.dataType == double) {
        x = double.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      } else if (xCol.dataType == int) {
        x = int.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      } else {
        x = int.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      }
    }

    return x;
  }

  calcCell_Positive(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (xCol.dataType == double) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = double.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    } else if (xCol.dataType == int) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = int.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    } else {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = int.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    }
    return x;
  }

  calcSconto(TextEditingController controller, String value) {
    if (controller.text == "") {
      return value.replaceAll("+", "");
    } else {
      return value;
    }
  }

  Future<void> play(Uint8List audioPayload, void Function(void Function()) setState) async {
    await selectedAudioPlayer.play(BytesSource(audioPayload));
  }

  Future<void> pause() async {
    await selectedAudioPlayer.pause();
  }

  cmd_OpenPhoto(Uint8List img, String imgID, {DateTime? dtImage}) async {
    await showDialog(
        context: context,
        builder: (builder) {
          return XAlertDialog(
              child: Container(
                  width: MediaQuery.of(context).size.width - 1,
                  height: MediaQuery.of(context).size.height - 1,
                  child: PhotoViewGallery.builder(
                      scrollPhysics: const BouncingScrollPhysics(),
                      builder: (BuildContext context, int index) {
                        return PhotoViewGalleryPageOptions(
                          basePosition: Alignment.center,
                          imageProvider: MemoryImage(img),
                          initialScale: PhotoViewComputedScale.contained * 1,
                          heroAttributes: PhotoViewHeroAttributes(tag: imgID),
                        );
                      },
                      itemCount: 1,
                      backgroundDecoration: BoxDecoration(color: Colors.grey[900]))),
              title_Text: dtImage != null ? "Foto del ${XUtils.dateToString(dtImage, format: "dd/MM/yy")}" : "Foto",
              title_Style: XStyles.xStyTextForLabel(textColor: Colors.yellow),
              content_insetPadding: EdgeInsets.all(0),
              actionsBTNarea_Child: Row(children: [
                Expanded(
                    child: XBtnbase(
                  height: 35,
                  backGroundColor: Colors.transparent,
                  onPressed: () => Navigator.pop(context),
                  elevation: 0,
                  label: "Chiudi",
                  label_Style: XStyles.xStyTextForLabel(textColor: Colors.red),
                ))
              ]));
        });
  }
}

abstract class AutocompleteItem {
  String? nickName;
  String? nome;
  String? cognome;
  String? cell;
  String? email;
}

class DynamicCli extends XFDataItem implements AutocompleteItem {
  DynamicCli(super.id, this.nickName, this.nome, this.cognome, this.cell, this.email);

  @override
  String? cognome;
  @override
  String? nickName;
  @override
  String? email;
  @override
  String? nome;
  @override
  String? cell;
}
